"""update_file_table_with_upload_id_and_updated_statusses

Revision ID: 71e0bcc916d6
Revises: 58562ef411b3
Create Date: 2023-11-21 15:46:40.180116

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '71e0bcc916d6'
down_revision: Union[str, None] = '58562ef411b3'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('files', sa.Column('upload_id', sa.String(), nullable=True))
    # ### end Alembic commands ###
    op.execute("ALTER TYPE filestatus RENAME VALUE 'unavailable' TO 'announced'")
    op.execute("CREATE TYPE filestatus_update AS ENUM ('announced', 'pending', 'secured');")
    op.execute("UPDATE files set status = 'secured' WHERE status = 'available';")
    op.execute("ALTER TABLE files ALTER COLUMN status TYPE filestatus_update USING (status::text::filestatus_update);")
    op.execute("DROP TYPE filestatus;")
    op.execute("ALTER TYPE filestatus_update RENAME TO filestatus;")


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('files', 'upload_id')
    # ### end Alembic commands ###
    op.execute("ALTER TYPE filestatus RENAME VALUE 'announced' TO 'unavailable'")
    op.execute("ALTER TYPE filestatus ADD VALUE 'available';")
    op.execute("UPDATE files set status = 'available' WHERE status = 'secured';")