"""added more permissions for buckets

Revision ID: a2fc6a2ffa1a
Revises: a67f3eec9109
Create Date: 2024-07-12 08:20:51.958082

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = 'a2fc6a2ffa1a'
down_revision: Union[str, None] = 'a67f3eec9109'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('s3_resource_permissions',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('resource_id', sa.Integer(), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=True),
    sa.Column('can_create_buckets', sa.Boolean(), nullable=False),
    sa.Column('can_add_users', sa.Boolean(), nullable=False),
    sa.ForeignKeyConstraint(['resource_id'], ['s3_resources.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('s3_bucket_permissions',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('bucket_id', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['bucket_id'], ['s3_buckets.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['users.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.drop_table('s3_permissions')
    op.add_column('s3_buckets', sa.Column('created_by_id', sa.Integer(), nullable=False, server_default='1'))
    op.create_foreign_key(None, 's3_buckets', 'users', ['created_by_id'], ['id'])
    op.alter_column('s3_resources', 'generic', nullable=False, new_column_name='public')
    op.add_column('s3_resources', sa.Column('created_by_id', sa.Integer(), nullable=False, server_default='1'))
    op.create_foreign_key(None, 's3_resources', 'users', ['created_by_id'], ['id'])
    op.drop_column('s3_resources', 'can_create_buckets')
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('s3_resources', sa.Column('can_create_buckets', sa.BOOLEAN(), autoincrement=False, nullable=False))
    op.add_column('s3_resources', sa.Column('generic', sa.BOOLEAN(), autoincrement=False, nullable=False))
    op.drop_constraint(None, 's3_resources', type_='foreignkey')
    op.drop_column('s3_resources', 'created_by_id')
    op.drop_column('s3_resources', 'public')
    op.drop_constraint(None, 's3_buckets', type_='foreignkey')
    op.drop_column('s3_buckets', 'created_by_id')
    op.create_table('s3_permissions',
    sa.Column('id', sa.INTEGER(), autoincrement=True, nullable=False),
    sa.Column('resource_id', sa.INTEGER(), autoincrement=False, nullable=False),
    sa.Column('user_id', sa.INTEGER(), autoincrement=False, nullable=False),
    sa.Column('can_add_users', sa.BOOLEAN(), autoincrement=False, nullable=False),
    sa.Column('can_revoke_users', sa.BOOLEAN(), autoincrement=False, nullable=False),
    sa.ForeignKeyConstraint(['resource_id'], ['s3_resources.id'], name='s3_permissions_resource_id_fkey'),
    sa.ForeignKeyConstraint(['user_id'], ['users.id'], name='s3_permissions_user_id_fkey'),
    sa.PrimaryKeyConstraint('id', name='s3_permissions_pkey')
    )
    op.drop_table('s3_bucket_permissions')
    op.drop_table('s3_resource_permissions')
    # ### end Alembic commands ###
